import { Misc, Utils } from "@singularsystems/neo-core";
import React from "react";
var BootstrapUtils = /** @class */ (function () {
    function BootstrapUtils() {
    }
    Object.defineProperty(BootstrapUtils.prototype, "isPre5", {
        /** Bootstrap version is before v5 */
        get: function () {
            return Misc.Settings.bootstrap.version < 5;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BootstrapUtils.prototype, "marginS", {
        /** Class prefix (without -) for start margin / left margin. */
        get: function () {
            return this.isPre5 ? "ml" : "ms";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BootstrapUtils.prototype, "marginE", {
        /** Class prefix (without -) for end margin / right margin. */
        get: function () {
            return this.isPre5 ? "mr" : "me";
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Gets the close button used in component headers.
     * @param pre5ClassName Class to add if bootstrap version is <5.
     */
    BootstrapUtils.prototype.getCloseButton = function (onClick, pre5ClassName) {
        pre5ClassName = Utils.joinWithSpaces("close", pre5ClassName);
        return this.isPre5 ?
            React.createElement("button", { type: "button", className: pre5ClassName, "aria-label": "Close", onClick: onClick },
                React.createElement("span", { "aria-hidden": "true" }, "\u00D7")) :
            React.createElement("button", { type: "button", className: "btn-close", "aria-label": "Close", onClick: onClick });
    };
    return BootstrapUtils;
}());
export default new BootstrapUtils();
