import { __assign, __extends, __rest } from "tslib";
import React from 'react';
import { Utils } from '@singularsystems/neo-core';
import BootstrapUtils from "./BootstrapUtils";
var FormGroupLayoutContextParams = /** @class */ (function () {
    function FormGroupLayoutContextParams() {
    }
    return FormGroupLayoutContextParams;
}());
export { FormGroupLayoutContextParams };
export var FormGroupLayoutContext = React.createContext(new FormGroupLayoutContextParams());
var GridLayout = /** @class */ (function (_super) {
    __extends(GridLayout, _super);
    function GridLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridLayout.prototype.render = function () {
        var _a = this.props, gutterSize = _a.gutterSize, verticalSpace = _a.verticalSpace, withGaps = _a.withGaps, alignItems = _a.alignItems, justifyContent = _a.justifyContent, formGroupProps = _a.formGroupProps, xs = _a.xs, sm = _a.sm, md = _a.md, lg = _a.lg, xl = _a.xl, xxl = _a.xxl, domProps = __rest(_a, ["gutterSize", "verticalSpace", "withGaps", "alignItems", "justifyContent", "formGroupProps", "xs", "sm", "md", "lg", "xl", "xxl"]);
        var isBsPre5 = BootstrapUtils.isPre5;
        var hasColumns = (xs || sm || md || lg || xl || xxl);
        var columnClassName = undefined;
        var isJustifyBetween = justifyContent === "between";
        var baseRowClassName = "row";
        if (!justifyContent) {
            columnClassName = Utils.joinWithSpaces((gutterSize !== undefined && isBsPre5) ? "px-" + gutterSize : undefined, xs && "col-" + 12 / xs, sm && "col-sm-" + 12 / sm, md && "col-md-" + 12 / md, lg && "col-lg-" + 12 / lg, xl && "col-xl-" + 12 / xl, xxl && "col-xxl-" + 12 / xxl);
            if (!hasColumns) {
                columnClassName = Utils.joinWithSpaces(columnClassName, "col-md-6");
            }
        }
        else {
            if (hasColumns) {
                console.error("GridLayout: Columns should not be specified if justifyContent is specified.");
            }
            baseRowClassName = "d-flex justify-content-" + justifyContent;
        }
        var rowClassName = Utils.joinWithSpaces(domProps.className, baseRowClassName, gutterSize && (isBsPre5 ? "mx-n" : "gx-") + gutterSize, alignItems && "align-items-" + alignItems);
        var containerStyle = domProps.style;
        var columnStyle = { marginLeft: "auto" };
        if (withGaps && !verticalSpace) {
            verticalSpace = "1rem";
        }
        if (verticalSpace) {
            containerStyle = containerStyle || {};
            containerStyle.marginTop = "-" + verticalSpace;
            columnStyle = { marginTop: verticalSpace, marginLeft: "auto" };
        }
        var childCount = React.Children.count(this.props.children);
        return (React.createElement(FormGroupLayoutContext.Provider, { value: { formGroupProps: formGroupProps } },
            React.createElement("div", __assign({}, domProps, { className: rowClassName, style: containerStyle }), React.Children.map(this.props.children, function (child, index) { return (child && React.createElement("div", { className: columnClassName, style: __assign(__assign({}, columnStyle), { marginLeft: childCount === 2 && index === 1 && isJustifyBetween ? "auto" : undefined }) }, child)); }))));
    };
    return GridLayout;
}(React.Component));
export default GridLayout;
